---
layout: default
manual_cookiebot: true
extra_css:
  - home.css
  - maturity.css
extra_js:
  - libs/on-scroll.js
  - all-clickable.js
  - libs/moment.min.js
  - maturity.js
title: "Maturity"
---

.container

  %p{style: "padding-top: 15px"}
    GitLab has a
    = succeed "," do
      %a{href: "/direction/"} broad scope and vision
    and we are constantly
    %a{href: "/handbook/values/#iteration"} iterating
    on existing and new features. Some stages and features are more mature than others. To convey the state of our feature set and be
    = succeed "," do
      %a{href: "/handbook/values/#transparency"} transparent
    we have developed a maturity framework for categories, application types, and stages.

  %a.scroll-anchor{id: "legend"}
  %table.legend-table
    %tr
      %td{style: "width: 50%"}
        %a{href: "#category-maturity"} Category
        and
        %a{href: "#application-type-maturity"} Application Type
        maturity:
        = partial "includes/product/maturity_legend"
      %td{style: "width: 50%"}
        %p
          %a{href: "#maturity-by-stage"} Stage
          lifecycle:
          %ul
            - for i in 0..7
              %li
                = lifecycle(i)

.container
  %section.maturity-tables

    %h2#category-maturity Category maturity

    %p
      GitLab features are grouped into a
      = succeed "," do
        %a{href: "/handbook/product/categories/#hierarchy"} hierarchy
      representing increasingly higher level capabilities. Features make up a broader Category, which then belong to a DevOps Stage.
      Stages are assigned a yearly
      = succeed "," do
        %a{href: "#legend"} lifecycle
      and categories a
      = succeed "." do
        %a{href: "#legend"} maturity

    .sdlc-container.position-relative#maturity-no-padding
      .sdlc-table
        - Gitlab::Homepage::Stage.all!.select{|stage| stage.marketing}.each do |stage|
          .sdlc-column
            .stage-container
              %a{href: "##{stage.key}"}
                = partial "/includes/icons/sdlc-icons/#{stage.key}.svg"
              %a{href: "##{stage.key}"}
                %p #{stage.display_name}
            .solutions-container
              - category_keys_active = data.categories.keys.keep_if { |k| data.categories[k].stage == stage.key && data.categories[k].marketing && data.categories[k].available && data.categories[k].available <= Date.today}
              - category_keys_upcoming = data.categories.keys.keep_if { |k| data.categories[k].stage == stage.key && data.categories[k].marketing && data.categories[k].available && data.categories[k].available > Date.today}
              - if category_keys_active.length >= 1
                .current-categories
                  %p.font-bold
                    Since
                    #{stage.established}
                    GitLab added:
                  .stage-column
                    .category-list
                      - category_keys_active.each do |key|
                        .category
                          .category-cell
                            %a{ href: "##{key}"}
                              = partial "/images/maturity/#{maturity(data.categories[key], Date.today)}.svg"
                          .category-cell
                            - url = data.categories[key].alt_link ? data.categories[key].alt_link : "/product/#{key.tr('_', '-').downcase}/"
                            %a{ href: "#{url}" } #{data.categories[key].name}
              - if category_keys_upcoming.length >= 1
                .future-categories
                  %p.font-bold
                    On our
                    = succeed ':' do
                      %br
                      %a.font-bold{ href: "#{stage.vision}"} roadmap
                  .stage-column
                    .category-list
                      - category_keys_upcoming.each do |key|
                        .category
                          .category-cell
                            %a{ href: "##{key}"}
                              = partial "/images/maturity/#{maturity(data.categories[key], Date.today)}.svg"
                          .category-cell
                            - url = data.categories[key].alt_link ? data.categories[key].alt_link : "/product/#{key.tr('_', '-').downcase}/"
                            %a{ href: "#{url}" } #{data.categories[key].name}

    %h2#maturity-plan Planned category maturity

    %p
      The maturity framework makes it easy to visualize where GitLab is making investments, and resulting category maturity improvements. As part of the
      %a{href: "https://about.gitlab.com/handbook/product/#planning-and-strategy"} planning process
      for each category, the set of features required and expected date to reach the next maturity is maintained. It can also be used to compare historical to planned velocity. A reduction in velocity is
      %a{href: "https://about.gitlab.com/handbook/leadership/biggest-risks/#loss-of-velocity"} one of our biggest risks.

    %p
      Below is a chart which illustrates the aggregate current and future progression of all categories.

    .drop-shadow
      .maturity-chart
        = maturity_chart()

    %h3#maturity-by-stage DevOps stage maturity

    - stages = data.stages.stages.select { |stageKey, stage| stage.marketing }
    = partial('includes/maturity/stage-details.html.haml', locals: { stages: stages })

    %h3#non-devops-maturity-by-stage Non-DevOps stage maturity

    - stages = data.stages.stages.select { |stageKey, stage| !stage.marketing }
    = partial('includes/maturity/stage-details.html.haml', locals: { stages: stages })

    %h2#application-type-maturity Application Type Maturity

    %p
      %a{href: "/handbook/product/application-types"} Application types
      represent different types of projects that people create and manage on GitLab. Much like our product categories, not all application types are at the same level of maturity. See below for where each application type currently stands and when they will reach higher
      = succeed "." do
        %a{href: "#legend"} maturity levels
    .drop-shadow
      %table.stage-table
        %tbody
          %tr
            %td
              Application Type
            %td.text-center
              Today
            %td.text-center
              Q4
            %td.text-center
              Q1
            %td.text-center
              Q2
            %td.text-center
              Q3
          %tr
            %td
              %i Date
            %td.text-center
              %i
                %span.today
            %td.text-center
              %i 2020-01-31
            %td.text-center
              %i 2020-04-30
            %td.text-center
              %i 2020-07-31
            %td.text-center
              %i 2020-10-31
          - data.application_types.each do |apptypeKey, apptype|
            %tr
              %td
                - if apptype.vision
                  %a{href: "#{apptype.vision}"} #{apptype.name}
                - else
                  = apptype.name
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(apptype, Date.today)}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(apptype, Date.new(2020,01,31))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(apptype, Date.new(2020,04,30))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(apptype, Date.new(2020,07,31))}.svg"
              %td.maturity-cell
                = partial "/images/maturity/#{maturity(apptype, Date.new(2020,10,31))}.svg"

    %h2 Changes
    %p
      Learn how to make changes to categories and their maturity on our
      = succeed "." do
        %a{ href: "../../handbook/marketing/website/#working-with-category-maturity"} website handbook page
